<?php
	error_reporting(E_ERROR);
	$tmp_path = getenv("CR_TMPDIR")."/.cr_java_tmp_".md5(getenv("CR_FILENAME")).".json";
	$tmp_data = json_decode(file_get_contents($tmp_path), true);
	$prompt = $argv[1];
	$matches = array();
	preg_match('/^(.*)\[(\d+)\]\s*$/', $prompt, $matches);
	$current_thread = $matches[1];
	$current_frame = $matches[2];
	
	$locations = array();
	$thread = "";
	while ($line = fgets(STDIN)) {
		$line = trim($line, "\n\r");
		if (substr($line, -1) == ":") {
			$thread = substr($line, 0, strlen($line)-1);
		} else {
			$matches = array();
			if (preg_match('/^\s*\[(\d+)\]\s+([^(]+?)\s+\((.*?)\)$/', $line, $matches)) {
				$location = array(
					"thread" => $thread,
					"frame_number" => intval($matches[1]),
					"name" => $matches[2]
				);
				$fileinfo = explode(":", $matches[3]);
				if (count($fileinfo) == 2) {
					$location["file"] = find_absolute_path($fileinfo[0], $location["name"], $thread);
					$location["line"] = str_replace(",", "", $fileinfo[1]);
				}
				if ($thread == $current_thread && $location["frame_number"] == $current_frame) {
					$location["current"] = true;
				}
				if (empty($locations) || $locations[count($locations)-1]["thread"] != $thread) {
					if ($location["frame_number"] != 1) {
						foreach ($tmp_data as $tmp_item) {
							if ($tmp_item["thread"] == $thread && $tmp_item["frame_number"] < $location["frame_number"]) {
								$tmp_item["current"] = false;
								array_push($locations, $tmp_item);
							}
						}
					}
				}
				array_push($locations, $location);
			}
		}
	}
	
	$out = json_encode($locations);
	$handle = fopen($tmp_path, 'w');
	fwrite($handle, $out);
	fclose($handle);
	
	echo $out;
	
	function find_absolute_path($relative_path, $location_name, $thread) {
		if (in_array($thread, array("Finalizer", "Reference Handler"))) {
			return $relative_path;
		}
		if (substr($location_name, 0, 5) === "java.") {
			return $relative_path;
		}
		$path = getcwd();
		if (file_exists_cached($path."/".$relative_path)) {
			return $path."/".$relative_path;
		} else {
			$components = explode(".", $location_name);
			if (count($components) > 1) {
				foreach ($components as $component) {
					$path = $path."/".$component;
					if (!file_exists_cached($path)) {
						return $relative_path;
					}
					if (file_exists_cached($path."/".$relative_path)) {
						return $path."/".$relative_path;
					}
				}
			}
		}
		return $relative_path;
	}
	
	function file_exists_cached($file) {
		static $cache = array();
		if (isset($cache[$file])) {
			return $cache[$file];
		}
		return $cache[$file] = file_exists($file);
	}
?>